#include <stdlib.h>
#include <iostream>
#include <string.h>
#include "alphabet.h"

#define SIZE 26
#define eol "\n"

using namespace std;

void print(alphabet* rows) {
	for (int i = 0; i < SIZE; i++) {
		for (int j = 0; j < SIZE; j++) {
			cout << rows[i].getChar(j) << " ";
		}
		cout << eol;
	}
}

void clear(alphabet* rows) {
	for (int i = 0; i < SIZE; i++) {
		rows[i].clear();
	}
}

char keyphrase[10] = {'l','i','n','u','x','t','o','o','l','s'};
char* decrypt(char* target, int size) {
	char* letters = (char*) malloc(sizeof(char) * SIZE);
	alphabet* rows = (alphabet*) malloc(sizeof(alphabet) * SIZE);


	char a = 'a';
	for (int i = 0; i < SIZE; i++) {
		letters[i] = a++;
	}

	for (int i = 0; i <= SIZE; i++) {
		alphabet newRow(letters, i);
		rows[i] = newRow;
	}

	char* result = (char*) malloc(sizeof(char) * size);
	for (int i = 0; i < size; i++) {
		int row = keyphrase[i % 10] - 97;
		int col = target[i] - 97;
		result[i] = rows[row].getChar(col);
	}

	free(letters);
	free(rows);
	return result;
}


int main() {
	while (true) {
		char* target = (char*) malloc(sizeof(char) * 30);
		cout << "Please enter a phrase to decrypt: ";
		cin >> target;
		int size = strlen(target);
		if (size < 1 || target[0] == '0') {
			free(target);
			break;
		}

		char* result = decrypt(target, size);
		cout << "Your decrypted string           : ";
		for (int i = 0; i < size; i++) {
			cout << result[i];
		}
		cout << eol << eol;

		free(target);
		free(result);
	}
	cout << eol << "Have a nice day!" << eol;

	return 0;
}
